package servidor;
import java.io.*;
import java.math.*;
import java.net.*;
import java.security.*;
import java.security.spec.*;
import javax.crypto.*;
import javax.crypto.spec.*;
 /**
 * <p>Servidor</p>
 *
 * <p>Crea los parmetros para DH, envia la clave pblica, recibe la pblica ajena
 *  y comunica mensajes usando AES para el cifrado</p>
 *
 * <p>Copyright: No se nada de eso</p>
 * <p>Puede usarlo a su antojo, solo me interesa q se de cuenta
 *  q java enreda TODO para hacer una simpleza</p>
 *
 * @OsKr
 * @version 1.0
 */
public class Servidor
{ ServerSocket       SS;
  Socket             S;
  BigInteger         p,g;
  int                l;
  KeyPairGenerator   KPG;
  DHParameterSpec    DHPS;
  KeyPair            KP;
  PrivateKey         PrivKey;
  PublicKey          PubKey;
  byte[]             PubKeyBytes;
  X509EncodedKeySpec X509EKS;
  KeyFactory         KF;
  KeyAgreement       KA;
  SecretKeySpec      SKS;
  public Servidor()
  { try
    { SS= new ServerSocket(5000);
      S=SS.accept();
      try
      { AlgorithmParameterGenerator paramGen = AlgorithmParameterGenerator.getInstance("DH");
        paramGen.init(512);
        AlgorithmParameters params = paramGen.generateParameters();
        DHPS = (DHParameterSpec)params.getParameterSpec(DHParameterSpec.class);
        p= DHPS.getP();
        g= DHPS.getG();
        l= DHPS.getL();
        KPG= KeyPairGenerator.getInstance("DH");
        KPG.initialize(DHPS);
        KP=KPG.generateKeyPair();
        PrivKey=KP.getPrivate();
        PubKey =KP.getPublic();
        PubKeyBytes=PubKey.getEncoded(); //Clave pblica a enviar al otro
        DataOutputStream DOS= new DataOutputStream(S.getOutputStream());
        DOS.writeUTF(""+p);
        DOS.writeUTF(""+g);
        DOS.writeInt(l);
        DOS.writeInt(PubKeyBytes.length);
        DOS.write(PubKeyBytes); //y se la mandamos
        /*Ahora recibimos la pblica de l*/
        DataInputStream DIS= new DataInputStream(S.getInputStream());
        int Longitud=DIS.readInt();
        PubKeyBytes=new byte[Longitud];
        DIS.read(PubKeyBytes);
        /*--------------------------------*/
        X509EKS = new X509EncodedKeySpec(PubKeyBytes);
        KF= KeyFactory.getInstance("DH");
        PubKey=KF.generatePublic(X509EKS);
        KA= KeyAgreement.getInstance("DH");
        KA.init(PrivKey);
        KA.doPhase(PubKey,true);
        //secretKey=ka.generateSecret("DES");
        SKS=new SecretKeySpec(KA.generateSecret(),0,16,"AES");
        /*Usamos cipher para enviar*/
        Cipher cipher= Cipher.getInstance("AES");
        cipher.init(Cipher.ENCRYPT_MODE,SKS);
        /*Primer mensaje a enviar*/
        byte[] cifered =cipher.doFinal(("Mensajeinho cifrado").getBytes());
        DOS.writeInt(cifered.length);
        DOS.write(cifered);
        /*segundo mensaje a enviar*/
        cifered =cipher.doFinal(("Ago's ta pasando").getBytes());
        DOS.writeInt(cifered.length);
        DOS.write(cifered);
        /*Usamos cipher2 para recibir*/
        Cipher cipher2= Cipher.getInstance("AES");
        cipher2.init(Cipher.DECRYPT_MODE,SKS);
        cifered= new byte[DIS.readInt()];
        DIS.read(cifered);
        /*Mensaje recibido*/
        System.out.println( new String(cipher2.doFinal(cifered)) );
      }
      catch(Exception e)
      { System.out.println(e.getMessage());
      }
    }
    catch(Exception Ex)
    { System.out.println(Ex.getMessage());
    }
  }
  public static void main(String[] args)
  { Servidor servidor = new Servidor();
  }
}